#
# TODO:
#   - package systemd stuff
#
Summary:	Remote desktop server
Summary(pl.UTF-8):	Serwer remote desktop
Name:		xrdp
Version:	0.9.8
Release:	2
License:	GPL
Group:		X11/Applications/Networking
Source0:	https://github.com/neutrinolabs/xrdp/releases/download/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	88a3c075583ccedf2183098478b57c17
Source1:	%{name}.init
Source2:	%{name}.pamd
Source3:	%{name}.README.PLD
Source4:	%{name}.README.PLD.pl
Source5:	startwm.sh
Patch0:		config.patch
Patch1:		quiet.patch
Patch2:		x32.patch
URL:		http://www.xrdp.org/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	libtool
BuildRequires:	openssl-devel
BuildRequires:	pam-devel
BuildRequires:	rpmbuild(macros) >= 1.268
Requires:	xrdp-libs = %{version}-%{release}
Requires(post,preun):	/sbin/chkconfig
Requires:	/usr/bin/Xvnc
Requires:	rc-scripts
Requires:	xinitrc-ng
Requires(postun):       /usr/sbin/groupdel
Requires(pre):  /usr/bin/getgid
Requires(pre):  /usr/sbin/groupadd
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
xrdp is an open source Remote Desktop Protocol (rdp) server for
UNIX-like systems. It is capable of accepting connections from
rdesktop and Microsoft's own terminal server / remote desktop clients.

Unlike Windows NT/2000/2003 server, xrdp will not display a Windows
desktop but an X window desktop to the user.

Xrdp uses Xvnc or X11rdp backends to manage the X session.

%description -l pl.UTF-8
xrdp jest serwerem protokołu Remote Desktop (rdp) dla systemów
UNIXowych. Do xrdp można się łączyć zarówno programem rdesktop, jak i
klientami protokołu rdp Microsoftu.

xrdp używa jako backendu Xvnc lub X11rdp.

%package -n xrdp-libs
Summary:        xrdp shared libraries
Summary(pl.UTF-8):      Biblioteki współdzielone xrdp
Group:          Libraries
Requires(post,postun):	/sbin/ldconfig

%description -n xrdp-libs
xrdp shared libraries.

%description -n xrdp-libs -l pl.UTF-8
Biblioteki współdzielone xrdp.

%package -n xrdp-devel
Summary:        Header files for xrdp libraries
Summary(pl.UTF-8):      Pliki nagłówkowe bibliotek xrdp
Group:          Development/Libraries
Requires:       xrdp-libs = %{version}-%{release}

%description -n xrdp-devel
Header files for xrdp libraries.

%description -n xrdp-devel -l pl.UTF-8
Pliki nagłówkowe bibliotek xrdp.

%package -n xrdp-static
Summary:        Static xrdp libraries
Summary(pl.UTF-8):      Statyczne biblioteki xrdp
License:        LGPL v2.1
Group:          Development/Libraries
Requires:       xrdp-devel = %{version}-%{release}

%description -n xrdp-static
Static xrdp libraries.

%description -n xrdp-static -l pl.UTF-8
Statyczne biblioteki xrdp.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1

install %{SOURCE3} README.PLD
install %{SOURCE4} README.PLD.pl

%build
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__autoheader}
%{__automake}
cd librfxcodec
%{__libtoolize}
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake}
cd ..
%configure
%{__make} V=1

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_sysconfdir}/{%{name},pam.d,rc.d/init.d,security}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

install %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/xrdp
install %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/pam.d/sesman
%{__rm} -f $RPM_BUILD_ROOT%{_sysconfdir}/pam.d/xrdp-sesman
%{__ln} -s sesman $RPM_BUILD_ROOT%{_sysconfdir}/pam.d/xrdp-sesman
%{__rm} $RPM_BUILD_ROOT%{_libdir}/%{name}/lib*.{a,la}
%{__rm} -f $RPM_BUILD_ROOT%{_sysconfdir}/xrdp/startwm.sh
install %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}/xrdp/startwm.sh

:> $RPM_BUILD_ROOT/etc/security/blacklist.sesman

%pre
%groupadd -g 183 xrdp

%post
/sbin/chkconfig --add xrdp
%service xrdp restart "xrdp server"

%preun
if [ "$1" = "0" ]; then
	%service xrdp stop
	/sbin/chkconfig --del xrdp
fi

%postun
if [ "$1" = "0" ]; then
	%groupremove xrdp
fi

%clean
rm -rf $RPM_BUILD_ROOT

%post	-n xrdp-libs -p /sbin/ldconfig
%postun	-n xrdp-libs -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc *.txt
%doc README.PLD
%doc README.PLD.pl
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/pam.d/sesman
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/security/blacklist.sesman
%attr(640,root,root) /etc/pam.d/xrdp-sesman
%attr(754,root,root) /etc/rc.d/init.d/xrdp
%dir %{_sysconfdir}/%{name}
%dir %{_sysconfdir}/%{name}/pulse
%config(noreplace) %{_sysconfdir}/%{name}/cert.pem
%config(noreplace) %{_sysconfdir}/%{name}/key.pem
%config(noreplace) %{_sysconfdir}/%{name}/rsakeys.ini
%config(noreplace) %{_sysconfdir}/%{name}/sesman.ini
%config(noreplace) %{_sysconfdir}/%{name}/xrdp.ini
%config(noreplace) %{_sysconfdir}/%{name}/xrdp_keyboard.ini
%{_sysconfdir}/%{name}/km-*.ini
%config(noreplace) %{_sysconfdir}/%{name}/pulse/default.pa
%attr(755,root,root) %{_sysconfdir}/xrdp/reconnectwm.sh
%attr(755,root,root) %{_sysconfdir}/xrdp/startwm.sh
%attr(755,root,root) %{_bindir}/xrdp-dis
%attr(755,root,root) %{_bindir}/xrdp-genkeymap
%attr(755,root,root) %{_bindir}/xrdp-keygen
%attr(755,root,root) %{_bindir}/xrdp-sesadmin
%attr(755,root,root) %{_bindir}/xrdp-sesrun
%attr(755,root,root) %{_sbindir}/xrdp
%attr(755,root,root) %{_sbindir}/xrdp-chansrv
%attr(755,root,root) %{_sbindir}/xrdp-sesman
%dir %{_libdir}/xrdp
%attr(755,root,root) %{_libdir}/xrdp/libcommon.so*
%attr(755,root,root) %{_libdir}/xrdp/libmc.so*
%attr(755,root,root) %{_libdir}/xrdp/libscp.so*
%attr(755,root,root) %{_libdir}/xrdp/libvnc.so*
%attr(755,root,root) %{_libdir}/xrdp/libxrdp.so*
%attr(755,root,root) %{_libdir}/xrdp/libxrdpapi.so*
%attr(755,root,root) %{_libdir}/xrdp/libxup.so*
%dir %{_datadir}/xrdp
%{_datadir}/xrdp/ad24b.bmp
%{_datadir}/xrdp/ad256.bmp
%{_datadir}/xrdp/cursor0.cur
%{_datadir}/xrdp/cursor1.cur
%{_datadir}/xrdp/sans-10.fv1
%{_datadir}/xrdp/xrdp24b.bmp
%{_datadir}/xrdp/xrdp256.bmp
%{_datadir}/xrdp/xrdp_logo.bmp
%{_mandir}/man1/xrdp-dis.1*
%{_mandir}/man5/sesman.ini.5*
%{_mandir}/man5/xrdp.ini.5*
%{_mandir}/man8/xrdp-chansrv.8*
%{_mandir}/man8/xrdp-genkeymap.8*
%{_mandir}/man8/xrdp-keygen.8*
%{_mandir}/man8/xrdp-sesadmin.8*
%{_mandir}/man8/xrdp-sesman.8*
%{_mandir}/man8/xrdp-sesrun.8*
%{_mandir}/man8/xrdp.8*

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpainter.so.*.*
%attr(755,root,root) %{_libdir}/librfxencode.so.*.*

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpainter.so
%attr(755,root,root) %{_libdir}/librfxencode.so
%{_includedir}/painter.h
%{_includedir}/rfxcodec_common.h
%{_includedir}/rfxcodec_decode.h
%{_includedir}/rfxcodec_encode.h
%{_includedir}/xrdp_client_info.h
%{_includedir}/xrdp_constants.h
%{_includedir}/xrdp_rail.h
%{_includedir}/xrdp_sockets.h
%{_pkgconfigdir}/libpainter.pc
%{_pkgconfigdir}/rfxcodec.pc
%{_pkgconfigdir}/xrdp.pc

%files static
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpainter.a
%attr(755,root,root) %{_libdir}/librfxencode.a
%changelog
* Mon Oct 22 2018 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/xrdp.git;a=log;h=master

* Mon Oct 22 2018 Jan Rękorajski <baggins@pld-linux.org> 1c80cff
- fix building on x32
- rel 2

* Mon Oct 22 2018 Jan Rękorajski <baggins@pld-linux.org> 19c5895
- up to 0.9.8
- freerdp is only needed for optional neutrinordp module, disable it

* Sat Sep 15 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> c8ec07d
- release 2 (by relup.sh)

* Thu Sep 06 2018 Marcin Krol <hawk@tld-linux.org> 185a953
- merged version 0.9.7 from TLD Linux:
  * patch bundled *.ini files instead of keeping local copy
  * create special group xrdp for allowed users
  * deny root login by default
  * added script for starting selected WM
  * higher loglevel
  * dropped kerberos auth, there is no pam fallback which prevents
    user login

* Sat Dec 07 2013 Jan Rękorajski <baggins@pld-linux.org> f36b3e9
- up to 0.6.1
- fix format string errors
- fix build with heimdal krb5
- other small fixes
- updated configs and init script

* Sat Apr 02 2011 Jarosław Skibiński <skibi@pld-linux.org> 17c05fb
- Update to versin 0.4.2

* Fri Apr 30 2010 pawelz <pawelz@pld-linux.org> 70884b4
- rel 3

* Tue Dec 30 2008 pawelz <pawelz@pld-linux.org> af532d7
- added note about signals.patch

* Wed Nov 26 2008 pawelz <pawelz@pld-linux.org> 2f4a444
- adapterized

* Wed Nov 26 2008 pawelz <pawelz@pld-linux.org> c0701fd
- simplified %%files section

* Tue Sep 23 2008 pawelz <pawelz@pld-linux.org> 1bf7136
- %post should restart not stop service

* Sun Sep 14 2008 Karol Krenski <charles@pld-linux.org> 3c8e42d
- BR: openssl-devel
- pass CC; rm LDFLAGS set (not needed)

* Wed Sep 10 2008 pawelz <pawelz@pld-linux.org> dd3859b
- added patch that fixes bug in sesman
- removed bug from known bugs list in README and README.pl
- rel 2

* Wed Sep 10 2008 pawelz <pawelz@pld-linux.org> 10e7dfd
- removed fixed bug from "known bugs"

* Wed Sep 10 2008 pawelz <pawelz@pld-linux.org> cee18cb
- bugfix
- sent to xrdp-devel mailing list

* Fri Jul 18 2008 pawelz <pawelz@pld-linux.org> 4d0bca9
- up to 0.4.1

* Mon Jul 14 2008 pawelz <pawelz@pld-linux.org> de9a48a
- %service deps

* Thu Jul 03 2008 pawelz <pawelz@pld-linux.org> 1662623
- adapterized

* Thu Jul 03 2008 Elan Ruusamäe <glen@pld-linux.org> e955f6f
- add try-restart, cosmetics

* Wed Jul 02 2008 pawelz <pawelz@pld-linux.org> 1dc61c5
- RDP server for UNIX
- initial release

